from flask import Flask, render_template, Response, redirect
from Video import video
import cv2
from PIL import Image
from PIL import ImageChops
import time

# initialisation
stop = 0
app = Flask(__name__)
vid=video()

# Fonction de la boucle pour capturer les images.
# La capture se fait dans le fichier Video.py -> la fonction get_frame

def flow():
	while True:
		frame = vid.get_frame()
		yield (b'--frame\r\n'
			   b'Content-Type: image/jpeg\r\n\r\n' + frame + b'\r\n')
		if stop == 1:
			break


# Fonction appelée par défaut
# Affiche l'index

@app.route('/')
def Accueil():
	stop = 0
	return render_template('index.html')

# Fonction qui appelle la page de capture vidéo

@app.route('/capture')
def capture_video():
	return render_template('video.html')

# /video_feed est appelée par le template pour calculer l'image
# appelle la fonction flow()

@app.route('/video_feed')
def video_feed():
	return Response(flow(),
		mimetype='multipart/x-mixed-replace; boundary=frame')

@app.route('/TakeImage')
def montage():
	# Fonction qui récupère la dernière frame de la caméra (quand on appuie sur le bouton)
	# et qui récupére l'image de Nawrou le dieu dans le dossier
	# et qui fait le montage photo
	ret, frame = vid.cam.read()
	video = cv2.cvtColor(frame, cv2.COLOR_BGR2RGB)

	photo = Image.fromarray(video)
	photo = photo.resize((1600, 1200))
	photo = photo.convert("RGB")

	Nawrou = Image.open("Nawrou.png")
	Nawrou = Nawrou.resize((1600, 1200))
	Nawrou = Nawrou.convert("RGB")


	imageMix = ImageChops.darker(photo, Nawrou)
	imageMix.save("static/images/img.jpg")

	# On l'envoie dans un format qu'il comprend (Merci Google)
	return redirect("/Dieu")

@app.route('/Dieu')
def Show():
	return render_template('Dieu.html', timestamp = time.time())

# Une autre manière de lancer son code -> il faut juste lancer le code Python ensuite
app.run()
